#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n, m;
vector<vector<int>> pref;

inline bool check(int x, int y, int xx, int yy) {
    int s = pref[xx][yy] - pref[xx][y] - pref[x][yy] + pref[x][y];
    return s == 0 || s == (xx - x) * (yy - y);
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    vector<string> f(n);
    for (int i = 0; i < n; i++) {
        cin >> f[i];
    }
    pref.assign(n + 1, vector<int> (m + 1));
    for (int i = 1; i < n + 1; i++) {
        for (int j = 1; j < m + 1; j++) {
            pref[i][j] = pref[i - 1][j]
                         + pref[i][j - 1]
                         - pref[i - 1][j - 1]
                         + (f[i - 1][j - 1] == 'X');
        }
    }

    vector<int> dn, dm;
    for (int i = 1; i <= n; i++) {
        if (n % i == 0) {
            dn.push_back(i);
        }
    }
    for (int i = 1; i <= m; i++) {
        if (m % i == 0) {
            dm.push_back(i);
        }
    }

    int ba = n, bb = m;
    int ans = n * m;
    for (int a : dn) {
        for (int b : dm) {
            bool ok = true;
            for (int i = 0; i < n; i += a) {
                for (int j = 0; j < m; j += b) {
                    if (!check(i, j, i + a, j + b)) {
                        ok = false;
                    }
                }
            }
            if (ok) {
                int cur = (n / a) * (m / b);
                if (cur < ans) {
                    ans = cur;
                    ba = n / a;
                    bb = m / b;
                }
            }
        }
    }

    cout << ba << " " << bb << endl;
    for (int i = 0; i < n; i += n / ba) {
        for (int j = 0; j < m; j += m / bb) {
            cout << f[i][j];
        }
        cout << "\n";
    }

    return 0;
}