#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<string> f(n);
    for (int i = 0; i < n; i++) {
        cin >> f[i];
    }

    vector<int> dn, dm;
    for (int i = 1; i <= n; i++) {
        if (n % i == 0) {
            dn.push_back(i);
        }
    }
    for (int i = 1; i <= m; i++) {
        if (m % i == 0) {
            dm.push_back(i);
        }
    }

    vector<vector<int>> pref(n);
    for (int i = 0; i < n; i++) {
        pref[i].resize(m + 1);
        for (int j = 0; j < m; j++) {
            pref[i][j + 1] = pref[i][j] + (f[i][j] == 'X');
        }
    }

    int L = -1;
    int R = dm.size();
    while (R - L > 1) {
        int M = (L + R) / 2;
        int d = dm[M];
        bool ok = true;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j += m / d) {
                int s = pref[i][j + m / d] - pref[i][j];
                if (s != 0 && s != m / d) {
                    ok = false;
                }
            }
        }
        if (ok) {
            R = M;
        } else {
            L = M;
        }
    }
    int b = dm[R];

    pref.resize(m);
    for (int j = 0; j < m; j++) {
        pref[j].resize(n + 1);
        for (int i = 0; i < n; i++) {
            pref[j][i + 1] = pref[j][i] + (f[i][j] == 'X');
        }
    }

    L = -1;
    R = dn.size();
    while (R - L > 1) {
        int M = (L + R) / 2;
        int d = dn[M];
        bool ok = true;
        for (int j = 0; j < m; j++) {
            for (int i = 0; i < n; i += n / d) {
                int s = pref[j][i + n / d] - pref[j][i];
                if (s != 0 && s != n / d) {
                    ok = false;
                }
            }
        }
        if (ok) {
            R = M;
        } else {
            L = M;
        }
    }
    int a = dn[R];

    cout << a << " " << b << endl;
    for (int i = 0; i < n; i += n / a) {
        for (int j = 0; j < m; j += m / b) {
            cout << f[i][j];
        }
        cout << "\n";
    }

    return 0;
}