#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include "testlib.h"
#include <unordered_set>

using namespace std;	
int N, M;	
vector<vector<int>> a;

int checkAns(InStream& stream) {

	string s = stream.readToken();
  
	if (s != "No" && s != "Yes") stream.quitf(_wa, "expected \"Yes\" or \"No\" in the first line");
	
	if (s == "No") return -1;

	unordered_set<int> ind;
	int n = stream.readInt(0, N, "number of reversed arrays");
	for (int i = 0; i < n; i++) {
		int x = stream.readInt(1, N, "one of the reversed arrays's index");
		if (ind.find(x) != ind.end()) stream.quitf(_wa, "index %d was used twice", x);
		ind.insert(x);
	}

	for (int j = 0; j < M; j++) {
		unordered_set<int> was;
		for (int i = 0; i < N; i++) {
			int nj = j;
			if (ind.find(i + 1) != ind.end()) nj = M - j - 1;
			if (was.find(a[i][nj]) != was.end()) stream.quitf(_wa, "number %d will be on position %d more than one time", a[i][nj], j + 1);
			was.insert(a[i][nj]);
		}
	}
	return 1;
}

int main(int argc, char *argv[]) {
	registerTestlibCmd(argc, argv);

	N = inf.readInt();
	M = inf.readInt();

	a.resize(N);
	for (int i = 0; i < N; i++) {
		a[i].resize(M);
		for (int j = 0; j < M; j++) {
			a[i][j] = inf.readInt();
		}
	}

	int j = checkAns(ans), p = checkAns(ouf);
    
	if (j == -1 && p != -1) quitf(_fail, "participant has correct solution");
	if (j == 1 && p == -1) quitf(_wa, "participant's answer in the first line is \"No\" but correct answer is \"Yes\" and solution exists");
	quitf(_ok, "%d lines", M + 2);
	return 0;
}