#include <bits/stdc++.h>
#include "testlib.h"
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

int readAns(InStream& stream, int n, int m, vector<set<int>> &M) {
	vector<int> del(n + 1);
	
	int lines = stream.readInt(-1, n, "lines");
	
	if (lines == -1) return -1;
	if (lines == 0) stream.quitf(_wa, "0 lines");
	
	for (int it = 0; it < lines; it++) {
		int len = stream.readInt(2, n, "len[i]");
		int v = stream.readInt(1, n, "vertex");
		
		if (del[v])
		    stream.quitf(_wa, "vertex %d was used twice", v);
		del[v] = 1;
		
		for (int i = 1; i < len; i++) {
			int to = stream.readInt(1, n, "vertex");
			if (del[to]) 
			    stream.quitf(_wa, "vertex %d was used twice", to);
			if (!M[v].count(to))
			    stream.quitf(_wa, "no edge (%d, %d)", v, to);
			del[to] = 1;
		}
	}
	for (int i = 1; i <= n; i++) if (!del[i])
		stream.quitf(_wa, "vertex %d was not used", i);
	return 1;
}

int main(int argc, char* argv[]) {
	registerTestlibCmd(argc, argv);
	

    int n = inf.readInt();
	int m = inf.readInt();
	
	vector<set<int> > M(n + 1);
	
	for (int i = 0; i < m; i++) {
		int a = inf.readInt(), b = inf.readInt(); 
		M[a].insert(b);
		M[b].insert(a);
	}
	
	int cO = readAns(ouf, n, m, M);
	int cA = readAns(ans, n, m, M);
	
	if (cA == 1 && cO == -1)
	    quitf(_wa, "solution exists");
	if (cA == -1 && cO == 1)
	    quitf(_fail, "participant found solution");
	
	quitf(_ok, "OK");
	return 0;
}