#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

vector<vector<int> > E, T;
vector<int> used, h, p;

void tree(int v) {
	used[v] = 1;
	for (int to : E[v]) if (!used[to]) {
		T[v].push_back(to);
		T[to].push_back(v);
		tree(to);
	}
}

void dfs(int v, int pr = -1) {
	h[v] = (pr == -1 ? 0 : h[pr] + 1);
	p[v] = pr;
	for (int to : T[v]) if (to != pr && h[to] != -1) dfs(to, v);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int n, m;
	cin >> n >> m;
	
	E.resize(n);
	T.resize(n);
	
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		E[a - 1].push_back(b - 1);
		E[b - 1].push_back(a - 1);
	}
	
	used.assign(n, 0), p.assign(n, -1);
	tree(0);
	
	int root = -1;
	for (int i = 0; i < n; i++) if (T[i].size() > 1) 
		root = i;
		
	if (root == -1) {
		assert(n <= 2);
		root = 0;
	}
	
	h.assign(n, 0);
	dfs(root);
	
	set<pair<int, int> > S;
	for (int i = 0; i < n; i++) S.insert({ h[i], i });
	
	vector<pair<int, vector<int>>> ans;
	int cntroot = (int)T[root].size();
	
	while (S.size() > 1) {
		int v = S.rbegin()->second;
		int t = p[v];
		assert(t != -1);
		
		S.erase({ h[t], t });
		assert(h[t] != -1);
		h[t] = -1;
		ans.push_back({ t, vector<int>(0) });
		
		for (int to : T[t]) if (to != p[t] && h[to] != -1) {
			ans.back().second.push_back(to);
			S.erase({ h[to], to });
			h[to] = -1;
		}
		
		if (p[t] == root) cntroot--;
		if (cntroot == 1) {
			cntroot = 0;
			for (int to : T[root]) if (h[to] != -1) {
			
				root = to;
				dfs(root);
				
				S.clear();
				for (int i = 0; i < n; i++) if (h[i] != -1)
					S.insert({ h[i], i });
			}
		}
	}
	
	if (S.size()) {
		assert(n == 1);
		puts("-1");
	} else {
		cout << ans.size() << "\n";
		for (auto c : ans) {
			cout << c.second.size() + 1 << "\n";
			cout << c.first + 1 << " ";
			for (int x : c.second) cout << x + 1 << " ";
			cout << "\n";
		}
	}
	return 0;
}